---
title: Encoding API
slug: Web/API/Encoding_API
tags:
  - API
  - Encoding
  - Overview
  - Reference
---
<p>{{DefaultAPISidebar("Encoding API")}}</p>

<p>The <strong>Encoding API</strong> provides a mechanism for handling text in various {{Glossary("character encoding", "character encodings")}}, including legacy non-{{Glossary("UTF-8")}} encodings.</p>

<p>The API provides four interfaces: {{domxref("TextDecoder")}}, {{domxref("TextEncoder")}}, {{domxref("TextDecoderStream")}} and {{domxref("TextEncoderStream")}}.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Interfaces">Interfaces</h2>

<div class="index">
<ul>
 <li>{{DOMxRef("TextDecoder")}}</li>
 <li>{{DOMxRef("TextEncoder")}}</li>
 <li>{{DOMxRef("TextDecoderStream")}}</li>
 <li>{{DOMxRef("TextEncoderStream")}}</li>
</ul>
</div>

<h2 id="Tutorials_tools">Tutorials &amp; tools</h2>

<ul>
 <li>A <a href="http://code.google.com/p/stringencoding/">shim</a> allowing to use this interface in browsers that don't support it.</li>
 <li><a href="/en-US/Add-ons/Code_snippets/StringView" title="/en-US/docs/Web/JavaScript/Typed_arrays/StringView"><code>StringView</code></a> – a C-like representation of strings based on typed arrays.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Encoding")}}</td>
   <td>{{Spec2("Encoding")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="TextDecoder"><code>TextDecoder</code></h3>

<p>{{Compat("api.TextDecoder")}}</p>

<h3 id="TextEncoder"><code>TextEncoder</code></h3>

<p>{{Compat("api.TextEncoder")}}</p>
